/* ObjElabGL.c */
/*Darstellung eines dreidimensionalen CGF-Objekts mit OpenGL*/

//#define DBL_BUF
#define MORE_OBJ
#define MIT_LOADCGF

#define CON_CLS   "cls"
#define ESC        27

#ifndef MIN
  #define MIN(x,y) (( (x) < (y) ) ? (x) : (y))
#endif  MIN
#ifndef MAX  
  #define MAX(x,y) (( (x) > (y) ) ? (x) : (y))
#endif  MAX

#include <conio.h>  //wg. _getch()
#include <stdio.h>  //wg. printf()
#include <stdlib.h> //wg. system()
#include <GL/glut.h>//wg. Konflikte: glut.h nach stdlib.h
#include "auxOps.h"
#include "LoadCGF.h"
#include "ObjElabGL.h"

CGFobject obj;
float   eyez=10., diag=10., viewScale=1., angle[3]={0.,0.,0.};
int     backF=0, persp=1, winWidth=300, winHeight=300; 
int     aa=0, shade=GL_FLAT, stipple=0, wire=GL_LINE;

GLdouble  nah=0., fern=0.;
GLfloat   colors[][4] = {
{1.0, 1.0, 1.0, 1.0},/*white  */
{1.0, 0.0, 0.0, 1.0},/*red    */
{0.0, 1.0, 0.0, 1.0},/*green  */
{0.0, 0.0, 1.0, 1.0},/*blue   */
{1.0, 1.0, 0.0, 1.0},/*yellow */
{1.0, 0.0, 1.0, 1.0},/*magenta*/
{0.0, 1.0, 1.0, 1.0},/*cyan   */
{0.6, 0.6, 0.6, 1.0},/*bright */
{0.3, 0.3, 0.3, 1.0},/*dark   */
{0.0, 0.0, 0.0, 1.0} /*black  */ 
};
GLubyte   fly[] = {
      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
      0x03, 0x80, 0x01, 0xC0, 0x06, 0xC0, 0x03, 0x60, 
      0x04, 0x60, 0x06, 0x20, 0x04, 0x30, 0x0C, 0x20, 
      0x04, 0x18, 0x18, 0x20, 0x04, 0x0C, 0x30, 0x20,
      0x04, 0x06, 0x60, 0x20, 0x44, 0x03, 0xC0, 0x22, 
      0x44, 0x01, 0x80, 0x22, 0x44, 0x01, 0x80, 0x22, 
      0x44, 0x01, 0x80, 0x22, 0x44, 0x01, 0x80, 0x22,
      0x44, 0x01, 0x80, 0x22, 0x44, 0x01, 0x80, 0x22, 
      0x66, 0x01, 0x80, 0x66, 0x33, 0x01, 0x80, 0xCC, 
      0x19, 0x81, 0x81, 0x98, 0x0C, 0xC1, 0x83, 0x30,
      0x07, 0xe1, 0x87, 0xe0, 0x03, 0x3f, 0xfc, 0xc0, 
      0x03, 0x31, 0x8c, 0xc0, 0x03, 0x33, 0xcc, 0xc0, 
      0x06, 0x64, 0x26, 0x60, 0x0c, 0xcc, 0x33, 0x30,
      0x18, 0xcc, 0x33, 0x18, 0x10, 0xc4, 0x23, 0x08, 
      0x10, 0x63, 0xC6, 0x08, 0x10, 0x30, 0x0c, 0x08, 
      0x10, 0x18, 0x18, 0x08, 0x10, 0x00, 0x00, 0x08};

GLubyte halftone[] = {
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55, 
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
      0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55};

/*************************************************************************/
  void move(void)
/*************************************************************************/
{ /*Objekt ins Sichtvolumen verschieben:*/
  glTranslatef(0.0, 0.0, -(nah+diag/2));
  /*Objekt positionieren:*/
#ifdef  MORE_OBJ
  glRotatef(angle[X], 1.0, 0.0, 0.0);
  glRotatef(angle[Y], 0.0, 1.0, 0.0);
  glRotatef(angle[Z], 0.0, 0.0, 1.0);
#endif//MORE_OBJ
}

/*************************************************************************/
  void drawObj (CGFobject *obj)
/*************************************************************************/
{ int jF, jP, dummyi=0;

  /*Sicherstellen: Ab hier Objekt- (nicht Projektions-)Trfn.:*/
  glMatrixMode(GL_MODELVIEW);

  /*Merke Uebernahmezustand und transformiere:*/
  glPushMatrix (); 
  move();

  /*Anderer Umgang mit dem Dreieck, zu erkennen am Namen: */
  if (!strncmp (obj->Name, "Triangle", strlen("Triangle"))) {;
#ifdef  MORE_OBJ
#endif//MORE_OBJ
  }

  /*Objekt zeichnen:*/
  for (jF=0; jF < obj->nFace; jF++)
  { /*Flaechen- und Linienmuster:*/
    if (!jF) { 
#ifdef  MORE_OBJ
#endif//MORE_OBJ 
               glLineStipple(5, 0x000F); }
    else     { 
#ifdef  MORE_OBJ
#endif//MORE_OBJ 
               glLineStipple(5, 0x0FFF); }
    /*Vorlaeufige Farbgebung:*/
    if (wire == GL_FILL && shade == GL_FLAT) 
    { glColor3ub((unsigned char)(colors[(jF+1)%10][0]*255), 
                 (unsigned char)(colors[(jF+1)%10][1]*255), 
                 (unsigned char)(colors[(jF+1)%10][2]*255));
    }
    glBegin(GL_POLYGON); 
    for (jP=0; jP < obj->Face[jF].nPnt; jP++)
    {
#ifdef  MORE_OBJ
#endif//MORE_OBJ 
      glVertex3fv(*obj->Face[jF].Pnt[jP]);
    } // Flaeche fertig
    glEnd();
  } // Objekt fertig
  glPopMatrix (); //Vergiss Trf. bis hierhin
}

/*************************************************************************/
  void display (void)
/*************************************************************************/
{ glClear(GL_COLOR_BUFFER_BIT);

  nah=eyez; fern=nah+2*diag;
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity(); //Tabula rasa...

  if (persp) /*Perspektive:*/
  { /*Mittige Plazierung der mit viewScale skalierten Szene:*/
    glViewport(winWidth*(1-viewScale)/2, winHeight*(1-viewScale)/2, 
               winWidth*viewScale,       winHeight*viewScale); 
    glFrustum (-diag, diag, -diag, diag, nah, fern);
  } else /*Parallel-Projektion:*/
  { glViewport(0, 0, winWidth, winHeight); 
    glOrtho (-diag, diag, -diag, diag, nah, fern);
  }
  /*Backface-Culling:*/
  if (backF) glEnable  (GL_CULL_FACE);
  else       glDisable (GL_CULL_FACE);

  /*Wireframe-AntiAliasing:*/
  if (aa && wire == GL_LINE) 
  { glEnable (GL_POINT_SMOOTH); glEnable (GL_LINE_SMOOTH);
    glEnable (GL_BLEND); glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  } else    { glDisable (GL_POINT_SMOOTH); glDisable (GL_LINE_SMOOTH);
              glDisable (GL_BLEND); }

  /*Einstellung fuer PolygonMode, Strichstaerke, Schattierung, Musterung:*/
  glPolygonMode(GL_FRONT_AND_BACK, wire);
#ifdef  MORE_OBJ
#endif//MORE_OBJ

  /*Bisherige Bewegung neu aufbauen (ohne Fehlerfortpflanzung):*/
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity(); 

  /*Objekt positionieren und zeichnen:*/
  drawObj(&obj); 

#ifdef  DBL_BUF
  glutSwapBuffers();
#else //DBL_BUF
  glFlush();
#endif//DBL_BUF
}

/*************************************************************************/
  void init (void)
/*************************************************************************/
/*(Erst- & einmalige Programm-Initialisierung inkl. Laden eines Objektes:*/
{
#ifdef  MIT_LOADCGF
  if (!loadCGF (&obj, CGF_FILE11) && !loadCGF (&obj, CGF_FILE12) && 
      !loadCGF (&obj, CGF_FILE21) && !loadCGF (&obj, CGF_FILE22))
#endif//MIT_LOADCGF
  setTriangleCGF (&obj);
  printCGF (&obj);   // Werte geladener Struktur-Variablen ausgeben
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity(); //Tabula rasa...

  /*Raumdiagonale der Bounding Box:*/
  diag = BBox(&obj);

  glClearColor(0.0, 0.0, 0.0, 0.0);

  /*Tastendruck simulieren, um Menue auszugeben:*/
  key(' ', 0, 0);

  return;
}

/*************************************************************************/
  void initPos(CGFobject *obj)
/*************************************************************************/
/*Erstmalige Positionierung und BBox-Berechnung eines geladenen Objekts:*/
{ printCGF (obj);  backF = 0;  eyez = 10.f;  viewScale=1.f;
  persp=1; aa=0; shade=GL_FLAT; stipple=0; 
  wire=GL_LINE;  glColor3f(1.,1.,1.); 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity(); //Tabula rasa...
  angle[X] = angle[Y] = angle[Z] =0.; 
  diag = BBox(obj);
  return;
}

/*************************************************************************/
  void key (unsigned char key, int x, int y)
/*************************************************************************/
/*Menue und Eingabe-Behandlung:*/
{ switch (key)
  { case ESC: exit(0);
#ifdef MIT_LOADCGF
    case '0': if (loadCGF (&obj, CGF_FILE01) || loadCGF (&obj, CGF_FILE02))
                initPos(&obj);
              else { glClear(GL_COLOR_BUFFER_BIT);
                     printf ("\n\n\r  LOAD FAILED !"); _getch(); }
              break;
    case '1': if (loadCGF (&obj, CGF_FILE11) || loadCGF (&obj, CGF_FILE12))
                initPos(&obj);
              else { glClear(GL_COLOR_BUFFER_BIT);
                     printf ("\n\n\r  LOAD FAILED !"); _getch(); }
              break;
    case '2': if (loadCGF (&obj, CGF_FILE21) || loadCGF (&obj, CGF_FILE22))
                initPos(&obj);
              else { glClear(GL_COLOR_BUFFER_BIT);
                     printf ("\n\n\r  LOAD FAILED !"); _getch(); }
              break;
    case '4': if (loadCGF (&obj, CGF_FILE41) || loadCGF (&obj, CGF_FILE42))
                initPos(&obj);
              else { glClear(GL_COLOR_BUFFER_BIT);
                     printf ("\n\n\r  LOAD FAILED !"); _getch(); }
              break;
    case '5': if (loadCGF (&obj, CGF_FILE51) || loadCGF (&obj, CGF_FILE52))
                initPos(&obj);
              else { glClear(GL_COLOR_BUFFER_BIT);
                     printf ("\n\n\r  LOAD FAILED !"); _getch(); }
              break;
#endif//MIT_LOADCGF
    case '3': if (setTriangleCGF (&obj)) 
                initPos(&obj);
              else { glClear(GL_COLOR_BUFFER_BIT);
                     printf ("\n\n\r  LOAD FAILED !"); _getch(); }
              break;
    case 'a': if (wire == GL_LINE) aa = 1 - aa;  else aa = 0;     break;
    case 'b': backF = 1-backF;                                    break;
    case 'e': eyez *=.9f;  viewScale /= .9f;                      break;
    case 'E': eyez *=1.1f; viewScale /= 1.1f;                     break;
    case 'p': persp = 1-persp;                                    break;
    case 's': if (wire == GL_FILL) 
              shade = GL_SMOOTH+GL_FLAT-shade;                    break;
    case 't': stipple = 1-stipple;                                break;
    case 'w': wire  = GL_LINE+GL_FILL - wire; 
              if (wire == GL_FILL) backF = 1; 
              else { glColor3f(1.,1.,1.);  shade = GL_FLAT; }     break;
    case 'x': angle[X] -= 5.; if (angle[X] <=-360) angle[X]+=360; break;
    case 'X': angle[X] += 5.; if (angle[X] >= 360) angle[X]-=360; break;
    case 'y': angle[Y] -= 5.; if (angle[Y] <=-360) angle[Y]+=360; break;
    case 'Y': angle[Y] += 5.; if (angle[Y] >= 360) angle[Y]-=360; break;
    case 'z': angle[Z] -= 5.; if (angle[Z] <=-360) angle[Z]+=360; break;
    case 'Z': angle[Z] += 5.; if (angle[Z] >= 360) angle[Z]-=360; break;
  }
  system (CON_CLS);
  printf ("\r Press (keeping the GLUT window activated):");
  printf ("\n\n\r <ESC> to quit");
#ifdef   MIT_LOADCGF
    printf ("\n\r 0/1/2/3  load Xface/cube/house/triangle/");
    printf ("\n\r ... 4/5  ... cylinder/sphere");
#endif //MIT_LOADCGF
  printf ("\n\r a        toggle wire frame AntiAliasing ");
  if (aa) printf ("(ON)"); else printf ("(OFF)"); 
  printf ("\n\r b        toggle Backface culling ");
  if (backF) printf ("(ON)"); else printf ("(OFF)"); 
  printf ("\n\r e / E    decrease/increase Eye point z-coord.");
  printf ("\n\r p        toggle projection: Persp."); 
  if (persp) printf ("(ON)");
  printf ("/orth."); if (!persp) printf ("(ON)");
  printf ("\n\r s        toggle Shading: smooth"); 
  if (shade == GL_SMOOTH) printf ("(ON)");
  printf ("/flat"); if (shade == GL_FLAT) printf ("(ON)");
  printf ("\n\r t        toggle sTippling ");
  if (stipple) printf ("(ON)"); else printf ("(OFF)"); 
  printf ("\n\r w        toggle PolygonMode: Wire"); 
  if (wire == GL_LINE) printf ("(ON)");
  printf ("/fill"); if (wire == GL_FILL) printf ("(ON)");
  printf ("\n\r x / X    decrease/increase X-rotation angle");
  printf ("\n\r y / Y    decrease/increase Y-rotation angle");
  printf ("\n\r z / Z    decrease/increase Z-rotation angle");
  printf ("\n\n\r Current values: eyez    =%7.2f", eyez);
  printf ("\n\r                 angle[X]=%7.2f", angle[X]);
  printf ("\n\r                 angle[Y]=%7.2f", angle[Y]);
  printf ("\n\r                 angle[Z]=%7.2f", angle[Z]);
  printf ("\n\r");
  display();
  return;
}

/*************************************************************************/
  int main (int argc, char **argv)
/*************************************************************************/
{ glutInit(&argc, argv);
/*Reihenfolge GLUT_ACCUM, GLUT_DOUBLE einhalten:*/
#ifdef  DBL_BUF
  glutInitDisplayMode(GLUT_DOUBLE);
#endif//DBL_BUF
  glutInitWindowSize(winWidth, winHeight);
  glutCreateWindow("CG goes OpenGL");
  glutDisplayFunc(display);
  glutKeyboardFunc(key);
  init(); 
  glutMainLoop();
  return 0;
}
#ifdef  EVEN_MORE
/*
Zur Berechnung von viewScale:
Verkuerzung von eyez bewirkt (bei konstanten glFrustum-Parametern)
eine Oeffnung des Sichtwinkels, so dass:
winWidth(neu) / winWidth(alt) = viewScale
Da die Fensterbreiten mittig "uebereinander gelegt" werden, 
gilt fuer die Startkoordinate x:
x(neu) = (winWidth(alt)-winWidth(neu)) / 2
(winHeight und y entsprechend)
max.Werte (danach Plazierung nicht mittig!?):
glViewport(-1900,-1900,4100,4100);
*/
#endif//EVEN_MORE
