/* lineOps.c */
/* Operationen zum Zeichnen gerader Linien. A. Christidis */

#include "lineOps.h" 

/*************************************************************************/
  void MidpointLine (int x0, int y0, int xn, int yn, char symbol)
/*************************************************************************/
{ int dx, dy, d;
  int incrE, incrNE; /*Increments for move to E & NE*/
  int x=x0, y=y0;    /*Start & current pixel*/

  dx=xn-x0; dy=yn-y0; d=2*dy-dx;
  incrE=2*dy; incrNE=2*(dy-dx); /*Increments E & NE*/

  for (x=x0; x < xn; x++)
  { conSetPixel (x, y, symbol);
    if (d < 0) { d += incrE; }       /* choose E  */
    else       { d += incrNE; y++; } /* choose NE */
  }
  return;
}

/*************************************************************************/
//Brute-force algorithm (DDA):
  void BruteForceLine (int x0, int y0, int xn, int yn, char symbol)
/*************************************************************************/
{ int x=x0;
  float y=(float)y0, m=(float)(yn-y0)/(xn-x0);
  
  for (x=x0; x <= xn; x++, y+=m)
      conSetPixel (x, (int)y, symbol);

  return;
}
